package com.zm.order.tool.server.engine;

import com.alibaba.fastjson.JSON;
import org.springframework.util.CollectionUtils;

import java.util.*;

/**
 * 客服
 *
 * @author nianchang
 * @ClassName ParseEngine4
 * @date 2021/06/17 10:58 上午
 */
@SuppressWarnings("all")
public class ParseEngine4 {

    public static Map<String, Object> parse(Map<String, Object> BaseMap, Map<String, Object> dataMap, String elName) {
        String id = BaseMap.get("id") != null ? BaseMap.get("id").toString() : "";
        Integer marginTop = BaseMap.get("marginTop") != null ? Integer.valueOf(BaseMap.get("marginTop").toString()) : 0;
        Integer marginBottom = BaseMap.get("marginBottom") != null ? Integer.valueOf(BaseMap.get("marginBottom").toString()) : 0;
        Integer marginRight = BaseMap.get("marginRight") != null ? Integer.valueOf(BaseMap.get("marginRight").toString()) : 0;
        Integer classType = BaseMap.get("classType") != null ? Integer.valueOf(BaseMap.get("classType").toString()) : 0;

        List<Map> customerList = JSON.parseArray(dataMap.get("data").toString(), Map.class);

        Map<String, Object> source = buildDataSource(elName, marginTop, marginBottom,
                marginRight, id, customerList, classType);
        return source;
    }

    private static Map<String, Object> buildDataSource(String elName, Integer marginTop, Integer marginBottom,
                                                       Integer marginRight, String id, List<Map> customerList,
                                                       Integer classType) {
        Map<String, Object> data = new HashMap<>();
        data.put("elName", elName);
        data.put("title", "客服");
        Map<String, Object> map = buildCommonStyleMap(marginTop, marginBottom, marginRight);
        data.put("commonStyle", map);
        data.put("isFixed", false);
        data.put("propsValue", buildPropsValue(classType, customerList));
        data.put("events", buildEvents());
        data.put("icon", "qimai-kefu2");
        data.put("id", id);
        String miniStyle = BuildStyle.build(map, elName);
        data.put("miniStyle", miniStyle);
        return data;
    }

    private static Map<String, Object> buildEvents() {
        Map<String, Object> eventsMap = new HashMap<>();
        eventsMap.put("type", "");
        eventsMap.put("page", buildPage());
        eventsMap.put("phone", "");
        eventsMap.put("audioUrl", "");
        eventsMap.put("alipay", buildAliPay());
        eventsMap.put("map", buildMap());
        return eventsMap;
    }

    private static Map<String, Object> buildMap() {
        Map<String, Object> map = new HashMap<>();
        map.put("lng", "");
        map.put("lat", "");
        map.put("name", "");
        map.put("address", "");
        return map;
    }

    private static Map<String, Object> buildAliPay() {
        Map<String, Object> alipay = new HashMap<>();
        alipay.put("tntInstId", "");
        alipay.put("scene", "");
        return alipay;
    }

    private static Map<String, Object> buildPage() {
        Map<String, Object> page = new HashMap<>();
        page.put("link", "");
        page.put("linkType", "");
        page.put("linkText", "");
        page.put("extraData", new HashMap<>());
        return page;
    }

    private static Map<String, Object> buildPropsValue(Integer classType, List<Map> customerList) {
        Map<String, Object> propsValue = new HashMap<>();
        propsValue.put("classType", classType);
        propsValue.put("customerList", buildCustomerList(customerList));
        return propsValue;
    }

    private static List<Map<String, Object>> buildCustomerList(List<Map> customerList) {
        List<Map<String, Object>> newCustomerList = new ArrayList<>();
        if (!CollectionUtils.isEmpty(customerList)) {
            for (Map<String, Object> map : customerList) {
                Map<String, Object> customerMap = new HashMap<>();
                customerMap.put("title", Objects.nonNull(map.get("title")) ? map.get("title") : "");
                customerMap.put("img", Objects.nonNull(map.get("img")) ? map.get("img") : "");
                customerMap.put("text", Objects.nonNull(map.get("text")) ? map.get("text") : "");
                customerMap.put("visible", Objects.nonNull(map.get("visible")) ? map.get("visible") : "");
                customerMap.put("type", Objects.nonNull(map.get("type")) ? map.get("type") : "");
                newCustomerList.add(customerMap);
            }
        }
        return newCustomerList;
    }

    private static Map<String, Object> buildPoints(String activeColor, Double inactiveOpacity, Integer bottomDistance) {
        Map<String, Object> points = new HashMap<>();
        points.put("bottomDistance", bottomDistance);
        points.put("inactiveOpacity", inactiveOpacity);
        points.put("activeColor", activeColor);
        return points;
    }

    private static Map<String, Object> buildCommonStyleMap(Integer marginTop, Integer marginBottom, Integer marginRight) {
        Map<String, Object> commonStyle = new HashMap<>();
        commonStyle.put("position", "relative");
        commonStyle.put("height", "auto");
        commonStyle.put("top", 0);
        commonStyle.put("left", 0);
        commonStyle.put("paddingTop", 0);
        commonStyle.put("paddingLeft", 0);
        commonStyle.put("paddingRight", 0);
        commonStyle.put("paddingBottom", 0);
        commonStyle.put("marginTop", marginTop);
        commonStyle.put("marginLeft", 0);
        commonStyle.put("marginRight", marginRight);
        commonStyle.put("marginBottom", marginBottom);
        commonStyle.put("borderWidth", 0);
        commonStyle.put("borderColor", "transparent");
        commonStyle.put("borderStyle", "solid");
        commonStyle.put("borderRadius", 0);
        commonStyle.put("boxShadow", "");
        commonStyle.put("fontSize", 14);
        commonStyle.put("fontWeight", 400);
        commonStyle.put("lineHeight", 24);
        commonStyle.put("letterSpacing", 0);
        commonStyle.put("textAlign", "left");
        commonStyle.put("color", "#333");
        commonStyle.put("backgroundColor", "");
        commonStyle.put("backgroundImage", "");
        commonStyle.put("backgroundSize", "contain");
        commonStyle.put("backgroundRepeat", "no-repeat");
        commonStyle.put("backgroundPosition", "center");
        commonStyle.put("opacity", 1);
        commonStyle.put("rotate", 0);
        commonStyle.put("zIndex", 1);
        return commonStyle;
    }
}
